Qore Programming Language: QoreNumberNode Class Reference

Qore Programming Language 0.8.11

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
QoreNumberNode Class Reference

Qore's arbitrary-precision number value type, dynamically-allocated only, reference counted. More...

`#include <QoreNumberNode.h>`

Inheritance diagram for QoreNumberNode:
[legend]
Collaboration diagram for QoreNumberNode:
[legend]

## Public Member Functions
DLLEXPORT | QoreNumberNode (const AbstractQoreNode *n)
| creates a new number value from the node, if not possible then the new number will be assigned 0
DLLEXPORT | QoreNumberNode (double f)
| creates a new number value and assigns the initial value to it More...
DLLEXPORT | QoreNumberNode (int64 i)
| creates a new number value and assigns the initial value to it More...
DLLEXPORT | QoreNumberNode (const char *str)
| creates a new number value and assigns the initial value to it More...
DLLEXPORT | QoreNumberNode (const char *str, unsigned prec)
| creates a new number value and assigns the initial value to it More...
DLLEXPORT | QoreNumberNode ()
| creates a new numbering-point value and assigns it to 0
DLLEXPORT | QoreNumberNode (const QoreNumberNode &old)
| creates a copy of the object
DLLEXPORT int | compare (const QoreNumberNode &n) const
| compares the argument to the current object, returns -1 if the current object is less than the argument, 0 if equals, and 1 if greater than the argument
DLLEXPORT int | compare (int64 n) const
| compares the argument to the current object, returns -1 if the current object is less than the argument, 0 if equals, and 1 if greater than the argument
DLLEXPORT int | compare (double n) const
| compares the argument to the current object, returns -1 if the current object is less than the argument, 0 if equals, and 1 if greater than the argument
DLLEXPORT QoreNumberNode * | doDivideBy (const QoreNumberNode &n, ExceptionSink *xsink) const
| add the argument to this value and return the result
DLLEXPORT QoreNumberNode * | doMinus (const QoreNumberNode &n) const
| add the argument to this value and return the result
DLLEXPORT QoreNumberNode * | doMultiply (const QoreNumberNode &n) const
| add the argument to this value and return the result
DLLEXPORT QoreNumberNode * | doPlus (const QoreNumberNode &n) const
| add the argument to this value and return the result
virtual DLLEXPORT int | getAsString (QoreString &str, int foff, class ExceptionSink *xsink) const
| concatenate the string representation of the number value to an existing QoreString More...
virtual DLLEXPORT QoreString * | getAsString (bool &del, int foff, class ExceptionSink *xsink) const
| returns a QoreString giving the string representation of the number value, sets del to true More...
virtual DLLEXPORT class DateTime * | getDateTimeRepresentation (bool &del) const
| returns the DateTime representation of this value and sets del to true More...
virtual DLLEXPORT void | getDateTimeRepresentation (DateTime &dt) const
| assigns the date representation of the value to the DateTime reference passed More...
DLLEXPORT unsigned | getPrec () const
| returns the precision of the number
virtual DLLEXPORT QoreString * | getStringRepresentation (bool &del) const
| returns the number value converted to a string and sets del to true More...
virtual DLLEXPORT void | getStringRepresentation (QoreString &str) const
| concatentates the number value to an existing QoreString reference, default implementation does nothing More...
virtual DLLEXPORT const char * | getTypeName () const
| returns the type name as a c string More...
virtual DLLEXPORT bool | is_equal_hard (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality without type conversions (hard compare) More...
virtual DLLEXPORT bool | is_equal_soft (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality with possible type conversion (soft compare) More...
DLLEXPORT QoreNumberNode * | negate () const
| returns the negative of the current object (this)
DLLEXPORT QoreNumberNode * | numberRefSelf () const
| returns a pointer to this with the reference count incremented
virtual DLLLOCAL AbstractQoreNode * | parseInit (LocalVar *oflag, int pflag, int &lvids, const QoreTypeInfo *&typeInfo)
| returns the type information
virtual DLLEXPORT AbstractQoreNode * | realCopy () const
| returns a copy of the object; the caller owns the reference count More...
DLLEXPORT int | sign () const
| returns -1 if the number is negative, 0 if zero, or 1 if the number is positive
DLLEXPORT void | toString (QoreString &str, int fmt=QORE_NF_DEFAULT) const
| concatenates the string value corresponding to the number to the string given More...
DLLEXPORT bool | zero () const
| returns true if the number is zero
Public Member Functions inherited from SimpleValueQoreNode
DLLLOCAL | SimpleValueQoreNode (qore_type_t t, bool n_there_can_be_only_one=false)
| creates the object by assigning the type code and setting the "value" flag, unsetting the "needs_eval" flag, and setting "there_can_be_only_one"
Public Member Functions inherited from SimpleQoreNode
DLLLOCAL | SimpleQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false)
| constructor takes the type and value arguments
DLLLOCAL | SimpleQoreNode (const SimpleQoreNode &v)
| copy constructor
Public Member Functions inherited from AbstractQoreNode
DLLEXPORT | AbstractQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false, bool n_custom_reference_handlers=false)
| constructor takes the type More...
DLLEXPORT | AbstractQoreNode (const AbstractQoreNode &v)
| copy constructor
DLLEXPORT int64 | bigIntEval (ExceptionSink *xsink) const
| evaluates the object and returns a 64-bit integer value More...
DLLEXPORT bool | boolEval (ExceptionSink *xsink) const
| evaluates the object and returns a boolean value More...
DLLEXPORT void | deref (ExceptionSink *xsink)
| decrements the reference count and calls derefImpl() if there_can_be_only_one is false, otherwise does nothing More...
DLLEXPORT AbstractQoreNode * | eval (ExceptionSink *xsink) const
| evaluates the object and returns a value (or 0) More...
DLLEXPORT AbstractQoreNode * | eval (bool &needs_deref, ExceptionSink *xsink) const
| optionally evaluates the argument More...
DLLEXPORT double | floatEval (ExceptionSink *xsink) const
| evaluates the object and returns a floating-point value More...
DLLEXPORT int64 | getAsBigInt () const
| returns the 64-bit integer value of the object More...
DLLEXPORT bool | getAsBool () const
| returns the boolean value of the object More...
DLLEXPORT double | getAsFloat () const
| returns the float value of the object More...
DLLEXPORT int | getAsInt () const
| returns the integer value of the object More...
DLLLOCAL qore_type_t | getType () const
| returns the data type More...
DLLEXPORT int | integerEval (ExceptionSink *xsink) const
| evaluates the object and returns an integer value More...
DLLLOCAL bool | is_value () const
| returns true if the node represents a value More...
DLLLOCAL bool | isReferenceCounted () const
| returns true if the object is reference-counted
DLLLOCAL bool | needs_eval () const
| returns true if the object needs evaluation to return a value, false if not More...
DLLEXPORT void | ref () const
| increments the reference count
DLLEXPORT AbstractQoreNode * | refSelf () const
| returns "this" with an incremented reference count More...
Public Member Functions inherited from QoreReferenceCounter
DLLEXPORT | QoreReferenceCounter ()
| creates the reference counter object
DLLEXPORT | ~QoreReferenceCounter ()
| destroys the reference counter object
DLLLOCAL bool | is_unique () const
| returns true if the reference count is 1 More...
DLLLOCAL int | reference_count () const
| gets the reference count More...
DLLEXPORT bool | ROdereference () const
| atomically decrements the reference count More...
DLLEXPORT void | ROreference () const
| atomically increments the reference count

## Static Public Member Functions
static DLLLOCAL qore_type_t | getStaticTypeCode ()
| returns the type code (useful in templates)
static DLLLOCAL const char * | getStaticTypeName ()
| returns the type name (useful in templates) More...
static DLLEXPORT QoreNumberNode * | toNumber (const AbstractQoreNode *v)
| returns the representation of the value as a number if possible (otherwise returns 0), caller owns the reference returned

## Protected Member Functions
virtual DLLEXPORT | ~QoreNumberNode ()
| the destructor is protected because it should not be called directly More...
Protected Member Functions inherited from SimpleValueQoreNode
virtual DLLEXPORT int64 | bigIntEvalImpl (ExceptionSink *xsink) const
| should never be called for value types More...
virtual DLLEXPORT bool | boolEvalImpl (ExceptionSink *xsink) const
| should never be called for value types More...
virtual DLLEXPORT AbstractQoreNode * | evalImpl (ExceptionSink *xsink) const
| should never be called for value types More...
virtual DLLEXPORT AbstractQoreNode * | evalImpl (bool &needs_deref, ExceptionSink *xsink) const
| should never be called for value types More...
virtual DLLEXPORT double | floatEvalImpl (ExceptionSink *xsink) const
| should never be called for value types More...
virtual DLLEXPORT int | integerEvalImpl (ExceptionSink *xsink) const
| should never be called for value types More...
Protected Member Functions inherited from AbstractQoreNode
virtual DLLEXPORT | ~AbstractQoreNode ()
| default destructor does nothing More...

## Protected Attributes
struct qore_number_private * | priv
| the private implementation of the type
Protected Attributes inherited from AbstractQoreNode
bool | custom_reference_handlers: 1
| set to one for objects that need custom reference handlers
bool | needs_eval_flag: 1
| if this is true then the type can be evaluated
bool | there_can_be_only_one: 1
| if this is set to true, then reference counting is turned off for objects of this class
qore_type_t | type: 11
| the type of the object More...
bool | value: 1
| this is true for values, if false then either the type needs evaluation to produce a value or is a parse expression
Protected Attributes inherited from QoreReferenceCounter
QoreThreadLock | mRO
| pthread lock to ensure atomicity of updates for architectures where we don't have an atomic increment and decrement implementation

## Detailed Description

Qore's arbitrary-precision number value type, dynamically-allocated only, reference counted.

## Constructor & Destructor Documentation

virtual DLLEXPORT QoreNumberNode::~QoreNumberNode | ( |  | ) |
| protectedvirtual

the destructor is protected because it should not be called directly

See Also
  SimpleValueQoreNode::deref()

DLLEXPORT QoreNumberNode::QoreNumberNode | ( | double | f | ) |

creates a new number value and assigns the initial value to it

Parameters

  f | the value for the object

DLLEXPORT QoreNumberNode::QoreNumberNode | ( | int64 | i | ) |

creates a new number value and assigns the initial value to it

Parameters

  i | the value for the object

DLLEXPORT QoreNumberNode::QoreNumberNode | ( | const char * | str | ) |

creates a new number value and assigns the initial value to it

Parameters

  str | the value for the object

DLLEXPORT QoreNumberNode::QoreNumberNode | ( | const char * | str,
|  | unsigned | prec
| ) |  |

creates a new number value and assigns the initial value to it

Parameters

  str | the value for the object
  prec | the initial precision for the number

## Member Function Documentation

virtual DLLEXPORT int QoreNumberNode::getAsString | ( | QoreString & | str,
|  | int | foff,
|  | class ExceptionSink * | xsink
| ) |  | const
| virtual

concatenate the string representation of the number value to an existing QoreString

used for n and N printf formatting

Parameters

  str | the string representation of the type will be concatenated to this QoreString reference
  foff | for multi-line formatting offset, ignored by this implementation of the function
  xsink | ignored by this implementation of the function

Returns
  -1 for exception raised, 0 = OK

Implements AbstractQoreNode.

virtual DLLEXPORT QoreString* QoreNumberNode::getAsString | ( | bool & | del,
|  | int | foff,
|  | class ExceptionSink * | xsink
| ) |  | const
| virtual

returns a QoreString giving the string representation of the number value, sets del to true

Used for n and N printf formatting. Do not call this function directly; use the QoreNodeAsStringHelper class (defined in QoreStringNode.h) instead

Parameters

  del | if this is true when the function returns, then the returned QoreString pointer should be deleted, if false, then it must not be
  foff | for multi-line formatting offset, ignored by this implementation of the function
  xsink | ignored by this implementation of the function

See Also
  QoreNodeAsStringHelper

Implements AbstractQoreNode.

virtual DLLEXPORT class DateTime* QoreNumberNode::getDateTimeRepresentation | ( | bool & | del | ) | const
| virtual

returns the DateTime representation of this value and sets del to true

The DateTime representation is calculated by converting the number value to an integer interpreted as the number of seconds offset from January 1, 1970.

Note
  Use the DateTimeValueHelper class instead of using this function directly

Parameters

  del | output parameter: if del is true, then the returned DateTime pointer belongs to the caller (and must be deleted manually), if false, then it must not be

See Also
  DateTimeValueHelper

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT void QoreNumberNode::getDateTimeRepresentation | ( | DateTime & | dt | ) | const
| virtual

assigns the date representation of the value to the DateTime reference passed

The DateTime representation is calculated by converting the number value to an integer interpreted as the number of seconds offset from January 1, 1970.

Parameters

  dt | the DateTime reference to be assigned

Reimplemented from AbstractQoreNode.

static DLLLOCAL const char* QoreNumberNode::getStaticTypeName | ( |  | ) |
| inlinestatic

returns the type name (useful in templates)

Returns
  the type name as a c string

virtual DLLEXPORT QoreString* QoreNumberNode::getStringRepresentation | ( | bool & | del | ) | const
| virtual

returns the number value converted to a string and sets del to true

NOTE: do not use this function directly, use QoreStringValueHelper instead

Parameters

  del | output parameter: del is set to true, meaning that the resulting QoreString pointer belongs to the caller (and must be deleted manually)

Returns
  a QoreString pointer, use the del output parameter to determine ownership of the pointer

See Also
  QoreStringValueHelper

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT void QoreNumberNode::getStringRepresentation | ( | QoreString & | str | ) | const
| virtual

concatentates the number value to an existing QoreString reference, default implementation does nothing

Parameters

  str | a reference to a QoreString where the value of the type will be concatenated

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT const char* QoreNumberNode::getTypeName | ( |  | ) | const
| virtual

returns the type name as a c string

Returns
  the type name as a c string

Implements AbstractQoreNode.

virtual DLLEXPORT bool QoreNumberNode::is_equal_hard | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const
| virtual

tests for equality without type conversions (hard compare)

Parameters

  v | the value to compare
  xsink | ignored by this implementation of the function

Returns
  true if the objects are equal, false if not

Implements AbstractQoreNode.

virtual DLLEXPORT bool QoreNumberNode::is_equal_soft | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const
| virtual

tests for equality with possible type conversion (soft compare)

Parameters

  v | the value to compare
  xsink | ignored by this implementation of the function

Returns
  true if the objects are equal, false if not

Implements AbstractQoreNode.

virtual DLLEXPORT AbstractQoreNode* QoreNumberNode::realCopy | ( |  | ) | const
| virtual

returns a copy of the object; the caller owns the reference count

Returns
  a copy of the object; the caller owns the reference count

Implements AbstractQoreNode.

DLLEXPORT void QoreNumberNode::toString | ( | QoreString & | str,
|  | int | fmt = `QORE_NF_DEFAULT`
| ) |  | const

concatenates the string value corresponding to the number to the string given

Parameters

  str | the string to append to
  fmt | a bitfield of number format flags

The documentation for this class was generated from the following file:

- include/qore/QoreNumberNode.h (6585)